*****************************************************************
                   BIDO3.0 

A modification of BIDO2.0 to process microtremor data by using coherence functions. In BIDO2.0, the cross spectral densities along a circle are weighted and averaged. This process is based on an assumption that the microtremor power is uniform everywhere, and then, sensitive to slight differences in either instrumental responses or installation conditions. For a practical purpose, this program uses complex coherences, instead of cross spectra, to stabilize the analysis results. BIDO3.0 has the following limitations, however:
* Array processing is done for vertical component only
  (i.e., only the vertical SPAC, CCA and nc-CCA methods applied).
* Preprocess option (e.g., band-pass filtering) is not available.

usage: 1) run.sh [return key]
       2) run.sh paramfile [return key]
       (paramfile will be created automatically by running this file)"

                           (C) 2020 by I. Cho. All Rights Reserved.
*****************************************************************

Before the analysis, you have to have all necessary input data files,
each one containing waveform records from a single sensor
and having a simple four-column or two-column format as follows:
      time [s]     z(UD)       x(EW)      y(NS)
or
      time [s]     z(UD)
(A space, a tab, or a comma may be used as a separator.)
There is no rule for naming the input data files, except that
all of them should be placed in a single directory. The number
of the input data files should be equal to the number of
seismic sensors in your microtremor array.
